﻿import ac
import acsys
import math
import time
import threading
import configparser
import os
import platform
import sys
import json
import random

if platform.architecture()[0] == "64bit":
	sysdir = os.path.dirname(__file__)+'/stdlib64'
else:
	sysdir = os.path.dirname(__file__)+'/stdlib'

sys.path.insert(0, sysdir)
os.environ['PATH'] = os.environ['PATH'] + ";."

from sim_info import info
from random import random
from array import *

car_name = ""
load_data = ""


time0 = 0
time1 = 0
time2 = 0
time3 = 0



def acMain(ac_version):
   global appWindow, isLoaded, car_name, move_x, move_y, move_z, rot_y, btn_save_data, speed_from, speed_to, speed_unit
   global info_text, info_text2
   
   car_name = ac.getCarName(0)   

   
   appWindow = ac.newApp("Performance meter")
   ac.setTitle(appWindow, "Performance meter")   
   ac.setSize(appWindow, 320, 310)
   ac.drawBorder(appWindow, 0)
   #ac.setIconPosition(appWindow, 0, -10000)   
   #ac.setBackgroundOpacity(appWindow,0)
   
   move_x = ac.addSpinner(appWindow, "move x")
   ac.setPosition(move_x, 50, 50)
   ac.setSize(move_x, 100, 20)
   ac.setValue(move_x, 0)
   ac.setRange(move_x, -1000, 1000)  
   ac.setStep(move_x, 1)             
 
   move_y = ac.addSpinner(appWindow, "move y")
   ac.setPosition(move_y, 50, 100)
   ac.setSize(move_y, 100, 20)
   ac.setValue(move_y, 100)
   ac.setRange(move_y, -1000, 1000)  
   ac.setStep(move_y, 1) 

   move_z = ac.addSpinner(appWindow, "move z")
   ac.setPosition(move_z, 50, 150)
   ac.setSize(move_z, 100, 20)
   ac.setValue(move_z, 50)
   ac.setRange(move_z, -1000, 1000)  
   ac.setStep(move_z, 1)            
 
   rot_y = ac.addSpinner(appWindow, "rotate y")
   ac.setPosition(rot_y, 50, 200)
   ac.setSize(rot_y, 100, 20)
   ac.setValue(rot_y, 0)
   ac.setRange(rot_y, 0, 360)  
   ac.setStep(rot_y, 1) 

   speed_unit = ac.addSpinner(appWindow, "Kmh - 0, Mph - 1")
   ac.setPosition(speed_unit, 180, 50)
   ac.setSize(speed_unit, 100, 20)
   ac.setRange(speed_unit, 0, 1) 
   ac.setValue(speed_unit, 0)   
   ac.setStep(speed_unit, 1) 
   
   speed_from = ac.addSpinner(appWindow, "Speed from:")
   ac.setPosition(speed_from, 180, 100)
   ac.setSize(speed_from, 100, 20)
   ac.setRange(speed_from, 1, 400) 
   ac.setValue(speed_from, 100)   
   ac.setStep(speed_from, 1) 

   speed_to = ac.addSpinner(appWindow, "Speed to:")
   ac.setPosition(speed_to, 180, 150)
   ac.setSize(speed_to, 100, 20)
   ac.setRange(speed_to, 10, 500) 
   ac.setValue(speed_to, 200)   
   ac.setStep(speed_to, 1) 
   
   btn_save_data = ac.addButton(appWindow, "Save car \n data")
   ac.setPosition(btn_save_data, 60, 250)
   ac.setSize(btn_save_data, 80, 40)
   ac.addOnClickedListener(btn_save_data, fun_save_data)
   ac.setFontSize(btn_save_data, 14)

   fun_load_data()
   
def acUpdate(deltaT):
   global time0, time1, speed_from, speed_to, speed_unit
   
   time0 = round(time.time() * 1000)
   if ((time1 + 33) < time0):
      ac.setRange(speed_from, 1, ac.getValue(speed_to) - 10)
      if (ac.getValue(speed_from) + 10) > ac.getValue(speed_to):
         ac.setValue(speed_from, ac.getValue(speed_to) - 10)	  
   
      time1 = round(time.time() * 1000)
	  
   #ac.ext_loadLua("turbo_count") 
   ac.ext_storeLua("move_x", ac.getValue(move_x))
   ac.ext_storeLua("move_y", ac.getValue(move_y))
   ac.ext_storeLua("move_z", ac.getValue(move_z))   
   ac.ext_storeLua("rot_y", ac.getValue(rot_y))
   ac.ext_storeLua("speed_from", ac.getValue(speed_from))
   ac.ext_storeLua("speed_to", ac.getValue(speed_to))   
   ac.ext_storeLua("speed_unit", ac.getValue(speed_unit))   
   #c.setRange(rpm_bar2, 2000, old_rpm_limiter)

   #extraF = ac.ext_loadLua("extraF")
 
	 
   #ac.ext_storeLua("set_boost_by_gear", set_boost_by_gear)
   #ac.log(str(gear_info))
 
def fun_save_data(*args):
   global move_x, move_y, move_z, rot_y, car_name
   
   profile = {} 
   profile["move_x"] = ac.getValue(move_x)
   profile["move_y"] = ac.getValue(move_y)
   profile["move_z"] = ac.getValue(move_z)
   profile["rot_y"] = ac.getValue(rot_y)   
   
   json_object = json.dumps(profile)
   
   with open("apps/python/Performance_meter/data/{}.json".format(car_name), "w") as outfile:
      outfile.write(json_object)  

def fun_load_data(*args):
   global move_x, move_y, move_z, rot_y, car_name, load_data


   if os.path.exists("apps/python/Performance_meter/data/{}.json".format(car_name)):
      load_data = "apps/python/Performance_meter/data/{}.json".format(car_name) 
	  
      with open(load_data, 'r') as openfile:
         json_object = json.load(openfile)

         ac.setValue(move_x, json_object["move_x"])  
         ac.setValue(move_y, json_object["move_y"])  
         ac.setValue(move_z, json_object["move_z"])  
         ac.setValue(rot_y, json_object["rot_y"])  	  